;;======================================================================================================
;; gdm_m1_ejot_delta_pt_bohrung.lsp V1.0
;; os / 15.11.2005

(in-package  :GDM)
(use-package :oli)

(sd-defdialog 'gdm-m1-ejot-delta-pt-bohrung-dialog
   :dialog-title "EJOT DELTA PT"
   :toolbox-button t
   :variables
   '(
     (BILD        :value-type :image
;                  :image-file (format nil "~a/LISP/gdm_m1_ejot_delta_pt_bohrung.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
				  :image-file "C:/ ... PFAD ANPASSEN ... /gdm_m1_ejot_delta_pt_bohrung.bmp")

     (AKT_PART    :value-type :part-incl-new
                  :modifies :contents
                  :title (sd-multi-lang-string "Part" :german "Teil")
                  :after-input (sd-call-cmds (current_part AKT_PART) :failure nil)
                  :prompt-text (sd-multi-lang-string "Specify Part." :german "Teil angeben."))

     (AKT_WP      :value-type :wp
                  :title (sd-multi-lang-string "Workplane" :german "AEbene")
                  :prompt-text (sd-multi-lang-string "Specify Workplane." :german "ArbeitsEbene angeben."))

     (W_EINZUG    :value-type :positive-number
                  :initial-value 0.5
                  :title (sd-multi-lang-string "Angle a" :german "Winkel a")
                  :check-function
                    #'(lambda (new-value)
                       (if (<= 0.5 new-value 0.75)
                           :ok
                           (values :error "Die Eingabe ist nicht im Bereich von [0.5 - 0.75]")
                       );;if
                      )
                  :prompt-text (sd-multi-lang-string "Specify Angle. Valid Range 0.5° - 0.75°." :german "Winkel angeben. Zulaessiger Bereich 0.5° - 0.75°."))

     (FAKT_DB     :value-type :positive-number
                  :initial-value 0.8
                  :title (sd-multi-lang-string "Factor db" :german "Faktor db")
                  :check-function
                    #'(lambda (new-value)
                       (if (<= 0.8 new-value 0.88)
                           :ok
                           (values :error (sd-multi-lang-string "The value is not in the Rang of [0.8 - 0.88]" :german "Die Eingabe ist nicht im Bereich von [0.8 - 0.88]"))
                       );;if
                      )
                  :prompt-text (sd-multi-lang-string "Specify Factor db. Valid Range 0.8 - 0.88." :german "Faktor db eingeben. Zulaessiger Bereich 0.8 - 0.88"))

     (FAKT_T1     :value-type :positive-number
                  :initial-value 0.3
                  :title (sd-multi-lang-string "Factor t" :german "Faktor t")
                  :check-function
                    #'(lambda (new-value)
                       (if (<= 0.3 new-value 0.4)
                           :ok
                           (values :error (sd-multi-lang-string "The value is not in the Rang of 0.3 - 0.4" :german "Die Eingabe ist nicht im Bereich von 0.3 - 0.4"))
                       );;if
                      )
                  :prompt-text (sd-multi-lang-string "Specify Factor t. Valid Range 0.3 - 0.4." :german "Faktor t eingeben. Zulaessiger Bereich 0.3 - 0.4."))

     (NENN_D      :title (sd-multi-lang-string "Nominal D." :german "Nenn D.") 
                  :range (( 2.00 :label " 20 / 2,0")
                          ( 2.20 :label " 22 / 2,2")
                          ( 2.50 :label " 25 / 2,5")
                          ( 3.00 :label " 30 / 3,0")
                          ( 4.00 :label " 40 / 4,0")
                          ( 4.50 :label " 45 / 4,5")
                          ( 5.00 :label " 50 / 5,0")
                          ( 6.00 :label " 60 / 6,0")
                          ( 7.00 :label " 70 / 7,0")
                          ( 8.00 :label " 80 / 8,0")
                          (10.00 :label "100 / 10,0"))
                  :after-input
                   (progn
                    (if (null DICKE_X)
                        (setq LAENGE_SMIN (+ (* NENN_D 2) (* NENN_D FAKT_T1)))
                        (setq LAENGE_SMIN (+ (* NENN_D 2) (* NENN_D FAKT_T1) DICKE_X))
                    )
                    (Schraubenlaenge_berechnen NENN_D LAENGE_SMIN)
                   );;progn
                  :prompt-text (sd-multi-lang-string "Specify Nominal Diameter." :german "Nenndurchmesser anngeben."))

     (DICKE_X     :value-type :length
                  :title "X"
                  :after-input
                   (progn
                    (setq LAENGE_SMIN (+ (* NENN_D 2) (* NENN_D FAKT_T1) DICKE_X))
                    (Schraubenlaenge_berechnen NENN_D LAENGE_SMIN)
                   );;progn
                  :prompt-text (sd-multi-lang-string "Specify Value X." :german "Wert X eingeben"))

     (DUMMY_TITLE_1 :title (sd-multi-lang-string "Screw Length" :german "Schraubenlaenge"))
     (LAENGE_SMIN :value-type :display-only
                  :title "Smin=X+t+tE")

     (LAENGE_V    :value-type :display-only
                  :title (sd-multi-lang-string "S Proposal" :german "S Vorschlag"))

     (LAENGE_S    :value-type :length
                  :proposals (4.00 4.50 5.00 6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00)
                  ;:range (4.00 4.50 5.00 6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00)
                  :title (sd-multi-lang-string "S selected" :german "S gewaehlt"))

     (PUNKT       :value-type :point-3d
                  :title (sd-multi-lang-string "Hole Center" :german "Bohrungsmitte")
                  :prompt-text (sd-multi-lang-string "Specify Point." :german "Punkt angeben."))

     ("")
     (NOTIZ       :title (sd-multi-lang-string "Label Drill-Hole" :german "Bohrung beschriften")
                  :value-type :boolean
                  :toggle-type :wide-toggle
                  :initial-value t)

     ("")
     (NEXT        :push-action (Ejot_delta_pt_bohrung_erstellen)
                  :after-input (setf PUNKT nil)
                  :next-variable 'PUNKT)

   );variables

   :local-functions
   '(
     (Ejot_delta_pt_bohrung_erstellen ()
       ;; WP kopieren
       (sd-call-cmds (create_workplane :copy :source AKT_WP :name "AE_tmp" :owner "/"))
       ;; GEO loeschen
       (sd-call-cmds (delete_2d :current_wp :edge_2d :all_2d) :failure nil)
       ;; AE positionieren
       (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :translate :two_ptv (sd-inq-wp-origin (sd-inq-curr-wp)) PUNKT))
       ;; AE um 90 Grad drehen
       (sd-call-cmds (position_wp :workplane (sd-inq-curr-wp) :rotate :axis :u :rotation_angle (/ pi 2) :done))
       (let (old-faces new-faces)
         ;;Liste 1 aller Flaechen des aktuellen Teils erstellen
         (sd-call-cmds (get_selection  :focus_type *sd-face-seltype* :curr_part_only :select :all_3d)
                                       :failure (setf old-faces nil)
                                       :success (setf old-faces *SD-ACTION-RESULT*))
         ;; Punkte berechnen
         (let (AP3 AP4 AP5 AP6 T1 T2 T3 P1 P2 P3 P4 P5 P6)
           (setf T1 (* NENN_D FAKT_T1))
           (setf T2 (- LAENGE_S DICKE_X T1))
           (setf T3 (/ NENN_D 2))

           (setf AP3 (* T3 (tan (sd-deg-to-rad W_EINZUG))))
           (setf AP4 (* T2 (tan (sd-deg-to-rad W_EINZUG))))
           (setf AP5 (* T1 (tan (sd-deg-to-rad W_EINZUG))))
           (setf AP6 (* 1 (tan (sd-deg-to-rad W_EINZUG))))

           (setf P1 (make-gpnt2d :x 0 :y 1))
           (setf P2 (make-gpnt2d :x 0 :y (- (+ T1 T2 T3))))
           (setf P3 (make-gpnt2d :x (- (/ (* NENN_D FAKT_DB) 2) AP3) :y (- (+ T1 T2 T3))))
           (setf P4 (make-gpnt2d :x (+ (/ (* NENN_D FAKT_DB) 2) AP4) :y (- T1)))
           (setf P5 (make-gpnt2d :x (- (/ (+ NENN_D 0.20) 2) AP5) :y (- T1)))
           (setf P6 (make-gpnt2d :x (+ (/ (+ NENN_D 0.20) 2) AP6) :y 1))
           ;; Profil erstellen
           (geometry_mode :real)
           (sd-call-cmds (polygon P1 P2 P3 P4 P5 P6 P1))
           (sd-call-cmds (fillet :create :fillet_radius (/ (- (- (/ (+ NENN_D 0.20) 2) AP5) (+ (/ (* NENN_D FAKT_DB) 2) AP4)) 2) P4 P5))
           (sd-call-cmds (fillet :create :fillet_radius (/ NENN_D 4) P3))
         );;let
         ;; Bohrung erstellen
         (sd-call-cmds (bore :parts AKT_PART :axis :v :rotation_angle (* 2 pi) :keep_wp :no))
         ;;Liste 2 aller Flaechen des aktuellen Teils erstellen
         (sd-call-cmds (get_selection  :focus_type *sd-face-seltype* :curr_part_only :select :all_3d)
                                       :failure (setf new-faces nil)
                                       :success (setf new-faces *SD-ACTION-RESULT*))
         ;; Liste 1 und 2 vergleichen und die neuen Flaechen einfaerben
         (if (null new-faces)
             (sd-display-message
                (sd-multi-lang-string "Error! There are no new Surfaces." :german "Fehler! Das Modell hat keine neuen Flaechen."))
             (dolist (a-face new-faces)
               (when (not (member a-face old-faces :test #'equal))
                     (sd-call-cmds (set_face_color a-face (sd-rgb-to-color 1,0,0)))
                     ;;
                     (if NOTIZ
                      (let (Kanten)
                       (when (sd-plane-p (sd-inq-geo-props a-face :dest-space :global))
                             (sd-call-cmds (get_selection :focus_type *sd-circle-3d-seltype*
                                                          :select :by_face a-face)
                                                          :failure nil
                                                          :success (setf Kanten *SD-ACTION-RESULT*))
                             (if (= (length Kanten) 1)
                                 (progn
                                  (let (NENN_D2)
                                   (case NENN_D
                                    ( 2.00 (setf NENN_D2 "20"))
                                    ( 2.20 (setf NENN_D2 "22"))
                                    ( 2.50 (setf NENN_D2 "25"))
                                    ( 3.00 (setf NENN_D2 "30"))
                                    ( 4.00 (setf NENN_D2 "40"))
                                    ( 4.50 (setf NENN_D2 "45"))
                                    ( 5.00 (setf NENN_D2 "50"))
                                    ( 6.00 (setf NENN_D2 "60"))
                                    ( 7.00 (setf NENN_D2 "70"))
                                    ( 8.00 (setf NENN_D2 "80"))
                                    (10.00 (setf NENN_D2 "100"))
                                   );;case
                                   (sd-call-cmds (cocreate_3d_note
                                                   :action :create :items a-face
                                                   :note (format nil "Bohrung_fuer_EJOT_DELTA_PT_~ax~a" NENN_D2 (sd-num-to-string LAENGE_S)))
                                   );;sd-call-cmds
                                  );;let
                                 );;progn
                             );;if
                       );;when
                      );;let
                     );;if NOTIZ
               );;when
             );;dolist
         );;if
       );;let old-faces new-faces
       ;; Urspungs WP aktiv setzen
       (sd-call-cmds (current_wp AKT_WP) :failure nil)
     );;Ejot_pt_bohrung_erstellen


     (Schraubenlaenge_berechnen (NENN_D LAENGE_SMIN)
       (let (SL)
        (case NENN_D
         (2.00 (setf SL '(4.00 4.50 5.00 6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00)))
         (2.20 (setf SL '(4.50 5.00 6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00)))
         (2.50 (setf SL '(5.00 6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00)))
         (3.00 (setf SL '(6.00 7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00)))
         (3.50 (setf SL '(7.00 8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00)))
         (4.00 (setf SL '(8.00 9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00)))
         (4.50 (setf SL '(9.00 10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00)))
         (5.00 (setf SL '(10.00 11.00 12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00 48.00 50.00)))
         (6.00 (setf SL '(12.00 14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00 48.00 50.00 60.00)))
         (7.00 (setf SL '(14.00 15.00 16.00 18.00 20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00 48.00 50.00 60.00 70.00)))
         (8.00 (setf SL '(20.00 21.00 22.00 24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00 48.00 50.00 60.00 70.00)))
         (10.00 (setf SL '(24.00 25.00 27.00 30.00 35.00 36.00 40.00 42.00 45.00 48.00 50.00 60.00 70.00)))
        );;case
        (sd-set-proposals 'LAENGE_S SL)
        ;(sd-set-range 'LAENGE_S SL)
        (loop while (< (first SL) LAENGE_SMIN) do
             (setf SL (rest SL))
             (if (endp SL)
                 (progn
                   (sd-display-message
                     (sd-multi-lang-string "The required Screw Length is not member of the Standard List."
                                   :german "Benoetigte Schraubenlaenge entspricht nicht der Standardliste"))
                   (setf DICKE_X nil)
                   (return)
                  );;progn
             );;if
        );;loop
        (setf LAENGE_V (first SL))
        (setf LAENGE_S (first SL))
       );;let
     );;Schraubenlaenge_berechnen

   );;local-functions

   :ok-action
   '(Ejot_delta_pt_bohrung_erstellen)

;   :help-action '(sd-display-url (format nil "file:~a/LISP/gdm_m1_ejot_delta_pt_bohrung.mht" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
   :help-action '(sd-display-url "C:/ ... PFAD ANPASSEN ... /gdm_m1_ejot_delta_pt_bohrung.mht")

);;sd-defdialog
;; ====eof
